#! /usr/bin/python3
# -*- coding: UTF-8 -*-
# 20.09.2014

# Alternativ für:
# - messagebox.askyesnocancel()
# - messagebox.askyesno()
# - messageboy.showinfo()

import tkinter as tk

def yesnocancel(master, title, text):
    """
    Ein Toplevel-Window, das drei Auswahloptionen bietet:
        'Ja', 'Nein', 'Abbrechen'
    Rückgabe 1, 0 , None
    """
    back = 0
    def _yes(e = None):
        nonlocal back
        back = 1
        top.quit()

    def _no(e = None):
        top.quit()

    def _quit(e = None):
        nonlocal back
        back = None
        top.quit()

    top = tk.Toplevel()
    top.protocol('WM_DELETE_WINDOW', _quit)
    top.title(title)

    top.update_idletasks()
    wpos = master.winfo_geometry().split('+')
    top.geometry("+{}+{}".format(int(wpos[1])+ 100, int(wpos[2]) + 100))
    top.resizable(width = None, height = None)
    top.bind('<Escape>', _quit)

    # Die erste Zeile ist die Textzeile (ggf. auch mehrzeilig)
    tk.Label(top, text = text, anchor = 'center' ). grid(
        column = 0, row = 0, columnspan = 3, padx = 10, pady = 10, sticky = "nsew")

    # Es folgen die drei Buttons
    btn1 = tk.Button(top, text = "Ja", command = _yes, width = 10)
    btn1.grid(column = 0, row = 1, padx = 10, pady = 10, sticky = "nsw")
    btn1.focus_force()
    btn1.bind('<Return>', _yes)

    btn2 = tk.Button(top, text = "Nein", command = _no, width = 10)
    btn2.grid(column = 1, row = 1, padx = 10, pady = 10, sticky = "nsw")
    btn2.bind('<Return>', _no)

    btn3 = tk.Button(top, text = "Abbrechen", command = _quit, width = 10)
    btn3.grid(column = 2, row = 1, padx = 10, pady = 10, sticky = "nsw")
    btn3.bind('<Return>', _quit)

    top.transient(master)
    top.grab_set()
    top.mainloop()
    top.destroy()

    return back


def yesno( master, title, text):
    """
    Ein Toplevel-Window, das zwei Auswahloptionen bietet:
        'Ja', 'Nein'

    Rückgabe 1 / 0
    """
    back = 0
    def _yes(e = None):
        nonlocal back
        back = 1
        top.quit()

    def _no(e = None):
        top.quit()

    top = tk.Toplevel()
    top.protocol('WM_DELETE_WINDOW', _no)
    top.title(title)

    top.update_idletasks()
    wpos = master.winfo_geometry().split('+')
    top.geometry("+{}+{}".format(int(wpos[1])+ 100, int(wpos[2]) + 100))
    top.resizable(width = None, height = None)
    top.bind('<Escape>', _no)

    # Die erste Zeile ist die Textzeile (ggf. auch mehrzeilig)
    tk.Label(top, text = text, anchor = 'center' ). grid(
        column = 0, row = 0, columnspan = 2, padx = 10, pady = 10, sticky = "nsew")

    # Es folgen die drei Buttons
    btn1 = tk.Button(top, text = "Ja", command = _yes, width = 10)
    btn1.grid(column = 0, row = 1, padx = 10, pady = 10, sticky = "nsw")
    btn1.focus_force()
    btn1.bind('<Return>', _yes)

    btn2 = tk.Button(top, text = "Nein", command = _no, width = 10)
    btn2.grid(column = 1, row = 1, padx = 10, pady = 10, sticky = "nsw")
    btn2.bind('<Return>', _no)

    top.transient(master)
    top.grab_set()
    top.mainloop()
    top.destroy()

    return back


def showinfo(master, title = "", text = ""):
    """
    Ein Toplevel-Window, das nur eine Meldung ausgibt und keine Rückgabe liefert,
    als def realisiert
    """

    def _quit(e = None):
        """ Escape | Return schließt das Fenster """
        top.quit()

    top = tk.Toplevel()
    top.protocol('WM_DELETE_WINDOW', _quit)
    top.title(title)
    top.bind('<Escape>', _quit)

    top.update_idletasks()
    wpos = master.winfo_geometry().split('+')
    top.geometry("+{}+{}".format(int(wpos[1])+ 100, int(wpos[2]) + 100))
    top.resizable(width = None, height = None)

    # Die erste Zeile ist die Textzeile (ggf. auch mehrzeilig)
    tk.Label(top, text = text, anchor = 'center' ). grid(
        column = 1, row = 0, columnspan = 2, padx = 10, pady = 10, sticky = "nsew")
    tk.Label(top, bitmap = 'info').\
            grid(column = 0, row = 0, padx = 10, pady = 10, sticky = "nsw")

    # Es folgen die zweite Zeile
    tk.Label(top, width = 10).\
            grid(column = 1, row = 1, padx = 10, pady = 10, sticky = "nsew")
    btn = tk.Button(top, text = "Weiter", command = _quit, width = 10)
    btn.grid(column = 2, row = 1, padx = 10, pady = 10, sticky = "nsew")
    btn.bind('<Return>', _quit)

    btn.focus_force()

    top.transient(master)
    top.grab_set()
    top.mainloop()
    top.destroy()


if __name__ == "__main__":

    t = tk.Tk()
    print(askyesno(t, title = "Appname", text = "Dies ist eine Information.\n"+\
                " Über mehrerer Zeilen\nsdjfj öasdfa\n sladjkfö."))
    t.destroy()
    t.mainloop()